{{# def.definitions }}
{{# def.setup:'dependencies' }}
{{# def.setupNextLevel }}


{{
  var $schemaDeps = {}
    , $propertyDeps = {};

  for ($property in $schema) {
    var $sch = $schema[$property];
    var $deps = Array.isArray($sch) ? $propertyDeps : $schemaDeps;
    $deps[$property] = $sch;
  }
}}

var {{=$errs}} = errors;

{{## def.checkPropertyDeps:
  {{~ $deps:$dep:$i }}
    {{?$i}} || {{?}}
    {{=$data}}{{= it.util.getProperty($dep) }} === undefined
  {{~}}
#}}

{{ for ($property in $propertyDeps) { }}
  if ({{=$data}}{{= it.util.getProperty($property) }} !== undefined) {
    {{ $deps = $propertyDeps[$property]; }}
    if ({{# def.checkPropertyDeps }}) {
      {{# def.error:'dependencies' }}
    } {{# def.elseIfValid }}
  }
{{ } }}


{{ for ($property in $schemaDeps) { }}
  {{ var $sch = $schemaDeps[$property]; }}
  {{? {{# def.nonEmptySchema:$sch }} }}
    valid{{=$it.level}} = true;

    if ({{=$data}}['{{= $property }}'] !== undefined) {
      {{ 
        $it.schema = $sch;
        $it.schemaPath = $schemaPath + "['" + it.util.escapeQuotes($property) + "']";
      }}

      {{= it.validate($it) }}
    }

    {{# def.ifResultValid }}
  {{?}}
{{ } }}

{{? $breakOnError }} 
  {{= $closingBraces }}
  if ({{=$errs}} == errors) {
{{?}}

{{# def.cleanUp }}
